'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = SyntaxHighlighter;

var _core = require('lowlight/lib/core');

var _core2 = _interopRequireDefault(_core);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Text = function Text(_ref) {
	var children = _ref.children;
	return _react2.default.createElement(
		'span',
		null,
		children
	);
};

var createStyleObject = function createStyleObject(classNames, style) {
	return classNames.reduce(function (styleObject, className) {
		return _extends({}, styleObject, style[className]);
	}, {});
};

function createChildren(style) {
	var childrenCount = 0;
	return function (children) {
		childrenCount += 1;
		return children.map(function (child, i) {
			return createElement(child, style, 'code-segment-' + childrenCount + '-' + i);
		});
	};
}
function createElement(node, style, key) {
	if (node.type === "text") {
		return _react2.default.createElement(
			Text,
			{ key: key },
			node.value
		);
	} else if (node.tagName) {
		var TagName = node.tagName;
		var properties = node.properties;

		var childrenCreator = createChildren(style);
		var nodeStyle = createStyleObject(properties.className, style);
		var children = childrenCreator(node.children);
		return _react2.default.createElement(
			TagName,
			{ key: key, style: nodeStyle },
			children
		);
	}
}

function SyntaxHighlighter(props) {
	var language = props.language;
	var children = props.children;
	var _props$stylesheet = props.stylesheet;
	var stylesheet = _props$stylesheet === undefined ? 'default' : _props$stylesheet;

	var style = require('./styles/' + stylesheet).default;
	var lang = require('highlight.js/lib/languages/' + language);
	_core2.default.registerLanguage(language, lang);
	var codeTree = _core2.default.highlight(language, children);
	var defaultPreStyle = style.hljs || { backgroundColor: '#fff' };
	return _react2.default.createElement(
		'pre',
		_extends({ style: defaultPreStyle }, props),
		_react2.default.createElement(
			'code',
			null,
			codeTree.value.map(function (node, i) {
				return createElement(node, style, 'code-segement' + i);
			})
		)
	);
}